#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "shoot2seven4search.py">
#<abstract4xi abstract = "shoots to direction seven"/>
#<refer4xi reference = "analyse2photo4search.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'shoot2seven4search']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 


#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
import version4xi
from version4xi import VersionKB4Xi
from version4xi import ROOT4XI   
try:    
    from dummyprocess4xi import DummyProcess4Xi
except:
    print("*** gun2seven4search: *** error: from dummyprocess4xi import DummyProcess4Xi ***")
    
try:    
    from process4xi import Process4Xi
except:
    print("*** gun2seven4search: *** error: from process4xi import Process4Xi ***")    
     
from time4xi import time4xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global base2build4seven

global count2ack4seven
global count2nack4seven
global count2found4seven
global count2short4seven

global current2series4seven
global candidate2series4seven

global fileobject4seven  

global keys2profile4seven
global key2profile4seven

global left2find4seven

global maxsize2ack4seven    
global maxsize2file4seven 
global max2short4seven
global meansize2ack4seven
global minsize2ack4seven

global seven2analyse4search

global profile2fetch4seven

global right2find4seven

global sumsize2ack4seven    

#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
base2build4seven = VersionKB4Xi['base2shoot4seven']             # base internet address, None=local url

count2ack4seven   = 0
count2nack4seven  = 0
count2found4seven = 0
count2short4seven = 0

left2find4seven = '('

max2short4seven = VersionKB4Xi['max2short4seven']
maxsize2file4seven = VersionKB4Xi['maxsize2file4seven']
maxsize2ack4seven  = 0
meansize2ack4seven = 0
minsize2ack4seven  = 0

current2series4seven = "current2series4seven5dummy"
candidate2series4seven  = "candidate2series4seven5dummy"


seven2analyse4search  = VersionKB4Xi['seven2analyse4search']

profile2fetch4seven = {}
profile2fetch4seven [1] = '.JPG'                             # object types to be aceepted for hyperlinks
profile2fetch4seven [2] = '.jpg'
keys2profile4seven = profile2fetch4seven.keys()

right2find4seven = ')'

sumsize2ack4seven  = 0

#"
#"/>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "build2hyperlink4seven" usage = "
#   builds hyperlinks
#"> 
# -------------------------------------------------------------------------------------------------
def build2hyperlink4seven(target2explore4seven):
    global count2ack4seven
    global count2nack4seven
    global count2found4seven
    global count2short4seven
    
    global fileobject4seven 
       
    global keys2profile4seven
    global key2profile4seven
    
    global left2find4seven

    global max2short4seven    
    global maxsize2file4seven     
    global maxsize2ack4seven    
    global meansize2ack4seven
    global minsize2ack4seven
  
    global candidate2series4seven
    global current2series4seven
    
    
    global profile2fetch4seven                         # extension for files
    
    global right2find4seven
    
    global sumsize2ack4seven    

       
    # ---------------------------------------------------------------------------------------------
    # INITIALIZE
    # ---------------------------------------------------------------------------------------------      
    count2found4seven = count2found4seven + 1
    ack2debug4seven = False                            # <-- True
 
    # ---------------------------------------------------------------------------------------------
    # SPLIT TARGET NAME WITH PATH AND EXTENSION TO TWO PIECES
    # ---------------------------------------------------------------------------------------------    
    name2target=os.path.splitext(target2explore4seven)
    
    ack2profile = False
    for key2profile4seven in keys2profile4seven:
        if name2target[1] == profile2fetch4seven[key2profile4seven]:                                                             
            ack2profile = True
    
    if ack2profile is True:     
        # -----------------------------------------------------------------------------------------
        # (Step 1/33) OF SHOOT2SEVEN4SEARCH - TARGET
        # -----------------------------------------------------------------------------------------
        path2input = target2explore4seven
        if ack2debug4seven is True:
            print("(STEP 0A/33) OF SHOOT2SEVEN4SEARCH - PATH2INPUT: ", path2input) 
            #  
        
        # -----------------------------------------------------------------------------------------
        # (Step 3/33) OF SHOOT2SEVEN4SEARCH - CHECK FILE STATUS
        # -----------------------------------------------------------------------------------------
        status2file = os.stat(path2input)
        size2file = status2file.st_size
        if size2file > maxsize2file4seven:
            count2nack4seven = count2nack4seven + 1
        else:
            count2ack4seven = count2ack4seven + 1
            sumsize2ack4seven = sumsize2ack4seven + size2file
            if size2file > maxsize2ack4seven:
                maxsize2ack4seven = size2file
            if ((size2file < minsize2ack4seven) or (minsize2ack4seven == 0)):
                print("(STEP 0B/33) OF SHOOT2SEVEN4SEARCH - USING MINSIZE2ACK4SEVEN: ", minsize2ack4seven, " SIZE2FILE: ", size2file ," PATH2INPUT: ", path2input) 
                # USING MINSIZE2ACK4SEVEN:  0  SIZE2FILE:  3866624  PATH2INPUT:  F://temp//yophotos//test2seven//d\sevenfly29july2012\sevenfly29july2012 (1).JPG 
                # USING MINSIZE2ACK4SEVEN:  3866624  SIZE2FILE:  3538944  PATH2INPUT:  F://temp//yophotos//test2seven//d\sevenfly29july2012\sevenfly29july2012 (2).JPG
                minsize2ack4seven = size2file
                print("(STEP 0C/33) OF SHOOT2SEVEN4SEARCH - SET MINSIZE2ACK4SEVEN TO: ", minsize2ack4seven, " = SIZE2FILE: ", size2file ," PATH2INPUT: ", path2input) 
                # SET MINSIZE2ACK4SEVEN TO:  3866624  = SIZE2FILE:  3866624  PATH2INPUT:  F://temp//yophotos//test2seven//d\sevenfly29july2012\sevenfly29july2012 (1).JPG
                # SET MINSIZE2ACK4SEVEN TO:  3538944  = SIZE2FILE:  3538944  PATH2INPUT:  F://temp//yophotos//test2seven//d\sevenfly29july2012\sevenfly29july2012 (2).JPG
                            
        # ==========================================================================================================
        # create hyperlink to image
        # ==========================================================================================================
        try:
            url2web4seven = target2explore4seven
            if ack2debug4seven is True:print("(STEP 1A/33) OF SHOOT2SEVEN4SEARCH - URL2WEB4SEVEN: ", url2web4seven) 
                # 
            
            ack2all4web = False
            string2edit = '\\'
            string2use = '/'
            while 1:
                if ack2all4web is True:
                    break
                else:
                    index2edit=str.find(url2web4seven,string2edit)   
                    if index2edit == -1:
                        ack2all4web = True
                    else:
                        url2web4seven = url2web4seven[0:index2edit] + string2use + url2web4seven[index2edit+1:]
                        
            name2web=os.path.splitext(url2web4seven)
            shortname2web4seven = name2web[0]
            if ack2debug4seven is True:
                print("(STEP 1B/33) OF SHOOT2SEVEN4SEARCH - SHORTNAME2WEB4SEVEN: ", shortname2web4seven)
                # 
            
            string2find4seven = '/'
            ackall2found4seven = False           
            while 1:
                if ackall2found4seven is True:
                    break
                else:
                    index2find4seven=str.find(shortname2web4seven,string2find4seven)   
                    if index2find4seven == -1:
                        ackall2found4seven = True
                    else:
                        shortname2web4seven = shortname2web4seven[index2find4seven+1:]
                        
            if ack2debug4seven is True:            
                print("(STEP 1C/33) OF SHOOT2SEVEN4SEARCH - SHORTNAME2WEB4SEVEN: ", shortname2web4seven)
                # 
                
            ackall2found4seven = False 
            while 1:
                if ackall2found4seven is True:
                    break
                else:
                    index2left4seven=str.find(shortname2web4seven,left2find4seven)
                    if index2left4seven == -1:
                        current2series4seven = shortname2web4seven
                        if ack2debug4seven is True:
                            print("(STEP 2A/33) OF SHOOT2SEVEN4SEARCH - CURRENT2SERIES4SEVEN: ", current2series4seven) 
                            # 
                        ackall2found4seven = True
                         
                    else:
                        index2right4seven=str.find(shortname2web4seven,right2find4seven)
                        if index2right4seven == -1:
                            ackall2found4seven = True 
                        else:
                            candidate2series4seven = shortname2web4seven[0:index2left4seven]
                            
                            index3find4seven=str.find(shortname2web4seven,current2series4seven)
                            if index3find4seven == -1:
                                
                                current2series4seven = candidate2series4seven
                                if ack2debug4seven is True:
                                    print("(STEP 2B/33) OF SHOOT2SEVEN4SEARCH - CURRENT2SERIES4SEVEN: ", current2series4seven) 
                                    # 
                                
                                count2short4seven = 0
                                fileobject4seven.write('<br />' + '\n')
                            else:
                                shortname2web4seven = shortname2web4seven[index2left4seven:index2right4seven+1]
                                if ack2debug4seven is True:
                                    print("(STEP 2C/33) OF SHOOT2SEVEN4SEARCH - SHORTNAME2WEB4SEVEN: ", shortname2web4seven)
                                    # 
                                
                                count2short4seven = count2short4seven + 1
                                if count2short4seven >= max2short4seven:
                                    count2short4seven = 0
                                else:
                                    pass       
                            ackall2found4seven = True
   
                                  
            # =======================================================================================================================
            # 
            # =======================================================================================================================                    
            if base2build4seven is None:
                # ===================================================================================================================
                # LOCAL URL
                # ===================================================================================================================
                fileobject4seven.write('<br /><b>&raquo;</b><a href="' + url2web4seven + '" target="_blank">' + shortname2web4seven + '</a>\n')                       
                
            else:
                # ===================================================================================================================
                # WEB URL
                # ===================================================================================================================            
                base2local4seven = seven2analyse4search
                if ack2debug4seven is True:
                    print("(STEP 3A/33) OF SHOOT2SEVEN4SEARCH - BASE2LOCAL4SEVEN: ", base2local4seven)
                    #              
                ack2localtries4seven = False                   
                while 1:
                    if ack2localtries4seven is True:
                        break
                    else:
                        index2find4seven=str.find(url2web4seven,base2local4seven)            
                        # 
                        #  
                        if index2find4seven == -1:
                            ack2localtries4seven = True
                        else:
                            if ack2debug4seven is True:
                                print("(STEP 3B/33) OF SHOOT2SEVEN4SEARCH - BASE2BUILD4SEVEN: ", base2build4seven)
                                # 
                            url2web4seven = base2build4seven + url2web4seven[len(base2local4seven):]
                            if ack2debug4seven is True:
                                print("(STEP 3C/33) OF SHOOT2SEVEN4SEARCH - URL2WEB4SEVEN: ", url2web4seven)
                                # 
                            
                            if count2short4seven < 1: 
                                fileobject4seven.write('<br /><b>&raquo;</b><a href="' + url2web4seven + '" target="_blank">' + shortname2web4seven + '</a>' + '\n')
                            else:
                                fileobject4seven.write('<b>&raquo;</b><a href="' + url2web4seven + '" target="_blank">' + shortname2web4seven + '</a>\n')                            
                            ack2localtries4seven = True 
                        
        except:
            print("(Step 4Z1/33 OF SHOOT2SEVEN4SEARCH FAILED, FILEOBJECT4SEVEN-WRITE-FAILED: ", str(fileobject4seven), time4xi())
      
    else:
        
        count2nack4seven = count2nack4seven + 1
        
                    
#</function4xi>
    

# =================================================================================================
#<class4xi class = "DirectoryWalker" base = "None" child = "None" synopsis = "a forward iterator that traverses a directory tree" usage = "
#   to review all tests"
#>
# =================================================================================================
class DirectoryWalker:

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init" usage = "initializes DirectoryWalker"> 
    # ---------------------------------------------------------------------------------------------
    def __init__(self, directory):
        self.stack = [directory]
        self.files = []
        self.index = 0
        
    #</methodize4xi>
            
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "getitem" usage = "getting item"> 
    # ---------------------------------------------------------------------------------------------
    def __getitem__(self, index):
        while 1:
            # ------------------------------------------------------------------------------------- 
            #
            # -------------------------------------------------------------------------------------          
            try:
                # --------------------------------------------------------------------------------- 
                #
                # ---------------------------------------------------------------------------------             
                file = self.files[self.index]
                self.index = self.index + 1
            except IndexError:
                # --------------------------------------------------------------------------------- 
                # pop next directory from stack
                # ---------------------------------------------------------------------------------             
                self.directory = self.stack.pop()
                self.files = os.listdir(self.directory)
                self.index = 0
            else:
                # --------------------------------------------------------------------------------- 
                # got a filename
                # ---------------------------------------------------------------------------------             
                fullname = os.path.join(self.directory, file)
                if os.path.isdir(fullname) and not os.path.islink(fullname):
                    self.stack.append(fullname)
                return fullname
    #</methodize4xi>
#</class4xi>
    

# -------------------------------------------------------------------------------------------------
#<function4xi function = "shoot2seven4search" usage = "analysing content">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def shoot2seven4search(queue2seven = None, consumer_channel2seven = None, publisher_channel2seven = None, path2seven = None):
    '''
    communicates via the given queue and named pipe channels if multiprocessing4xi is being used 
    '''
    global count2ack4seven
    global count2nack4seven
    global count2found4seven
    
    global fileobject4seven    
    
    global maxsize2ack4seven    
    global meansize2ack4seven
    global minsize2ack4seven
    global sumsize2ack4seven    
    
    global maxsize2file4seven 
    
    global profile2fetch4seven                         # extension for files
    global keys2profile4seven
    global key2profile4seven

        
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    print("(STEP 0A/33) OF SHOOT2SEVEN4SEARCH - STARTED TIME: ", time2start)   
    # 
    print("(STEP 0B/33) OF SHOOT2SEVEN4SEARCH -  QUEUE2SEVEN: ", queue2seven)      
    # QUEUE2SEVEN:  <queue4xi.Queue4Xi object at 0x02A5D930>
    
    print("(STEP 0C/33) OF SHOOT2SEVEN4SEARCH -  CONSUMER_CHANNEL2SEVEN: ", consumer_channel2seven)
    # CONSUMER_CHANNEL2SEVEN:  <pipeconnection4xi.PipeConnection4Xi object at 0x02A5DB10>
          
    print("(STEP 0D/33) OF SHOOT2SEVEN4SEARCH -  PUBLISHER_CHANNEL2SEVEN: ", publisher_channel2seven)          
    # PUBLISHER_CHANNEL2SEVEN:  <pipeconnection4xi.PipeConnection4Xi object at 0x02A5D4F0>

    if ((queue2seven is None) or (consumer_channel2seven is None) or (publisher_channel2seven is None)):
        # -----------------------------------------------------------------------------------------
        # COMMAND AND CONTROL MECHANISM NOT GIVEN - MULTIPROCESSING NOT USED
        # -----------------------------------------------------------------------------------------
        print("(STEP 1A/33) OF SHOOT2SEVEN4SEARCH - COMMAND AND CONTROL MECHANISM NOT GIVEN - MULTIPROCESSING NOT USED")
        print("(STEP 1B/33) OF SHOOT2SEVEN4SEARCH - QUEUE2SEVEN: ", queue2seven)
        print("(STEP 1C/33) OF SHOOT2SEVEN4SEARCH - CONSUMER_CHANNEL2SEVEN: ", consumer_channel2seven) 
        print("(STEP 1D/33) OF SHOOT2SEVEN4SEARCH - PUBLISHER_CHANNEL2SEVEN: ", publisher_channel2seven)
        print("(STEP 1E/33) OF SHOOT2SEVEN4SEARCH - PATH2SEVEN: ", path2seven)     
        
        return
 
    if (not (queue2seven is None) and not(consumer_channel2seven is None) and not(publisher_channel2seven is None) and (path2seven is None)): 
        # -----------------------------------------------------------------------------------------
        # COMMAND AND CONTROL (CC) MECHANISM OK, BUT PATH MISSING - CAN BE USED FOR TESTING CC 
        # -----------------------------------------------------------------------------------------
        print("(STEP 2A/33) OF SHOOT2SEVEN4SEARCH - COMMAND AND CONTROL MECHANISM OK, BUT PATH MISSING")                       
        print("(STEP 2B/33) OF SHOOT2SEVEN4SEARCH - QUEUE2SEVEN: ", queue2seven)
        print("(STEP 2C/33) OF SHOOT2SEVEN4SEARCH - CONSUMER_CHANNEL2SEVEN: ", consumer_channel2seven) 
        print("(STEP 2D/33) OF SHOOT2SEVEN4SEARCH - PUBLISHER_CHANNEL2SEVEN: ", publisher_channel2seven)
        print("(STEP 2E/33) OF SHOOT2SEVEN4SEARCH - PATH2SEVEN: ", path2seven)     
        return           

    if (not (queue2seven is None) and not(consumer_channel2seven is None) and not(publisher_channel2seven is None) and not(path2seven is None)): 
        # -----------------------------------------------------------------------------------------
        # COMMAND AND CONTROL MECHANISM OK AND PATH ALSO GIVEN - PRODUCTION VERSION
        # -----------------------------------------------------------------------------------------
        print("(STEP 3A/33) OF SHOOT2SEVEN4SEARCH - COMMAND AND CONTROL MECHANISM OK AND PATH ALSO GIVEN")                       
        
        print("(STEP 3B/33) OF SHOOT2SEVEN4SEARCH - QUEUE2SEVEN: ", queue2seven)
        # QUEUE2SEVEN:  <queue4xi.Queue4Xi object at 0x02A5D930>
         
        print("(STEP 3C/33) OF SHOOT2SEVEN4SEARCH - CONSUMER_CHANNEL2SEVEN: ", consumer_channel2seven)
        # CONSUMER_CHANNEL2SEVEN:  <pipeconnection4xi.PipeConnection4Xi object at 0x02A5DB10>
        print("(STEP 3D/33) OF SHOOT2SEVEN4SEARCH - PUBLISHER_CHANNEL2SEVEN: ", publisher_channel2seven)
        # PUBLISHER_CHANNEL2SEVEN:  <pipeconnection4xi.PipeConnection4Xi object at 0x02A5D4F0>
        print("(STEP 3E/33) OF SHOOT2SEVEN4SEARCH - PATH2SEVEN: ", path2seven)
        # PATH2SEVEN:  F://temp//yophotos//test2seven//
       
        print("(STEP 4A/33) OF SHOOT2SEVEN4SEARCH - STARTING TO WALK PATH2SEVEN: ", path2seven)   
        # STARTING TO WALK PATH2SEVEN:  F://temp//yophotos//test2seven//
        
        # ==========================================================================================================
        # DYNAMICALLY BUILD HTML FILE USING SUBDIRECTORIES
        # ==========================================================================================================
        path2index4seven = None
        try:
            name2index4seven = "index2xxxxxxxx4yo.html"
            path2index4seven = path2seven + name2index4seven
            print("(Step 4B/33) OF SHOOT2SEVEN4SEARCH - SET PATH2INDEX4SEVEN TO: ", path2index4seven)
            # R://temp//yophotos//test//index2xxxxxxxx4yo.html
        except:
            print("(Step 4Z1/33) OF SHOOT2SEVEN4SEARCH *** FAILED TO INITIALIZE PATH2INDEX4SEVEN: ", path2index4seven)          
            #                    
        fileobject4seven = None
        try:
            fileobject4seven = open(path2index4seven,'w')
            print("(Step 4C/33) OF SHOOT2SEVEN4SEARCH - OPENED OUTPUT: ", fileobject4seven)
            # SHOOT2SEVEN4SEARCH - OPENED OUTPUT:  <_io.TextIOWrapper name='F://temp//yophotos//test2seven//index2xxxxxxxx4yo.html' mode='w' encoding='cp1252'>
        except:
            print("(Step 4Z2/33) OF SHOOT2SEVEN4SEARCH *** FAILED TO OPEN OUTPUT: ", fileobject4seven)         
            # 
        try:                
            fileobject4seven.write('<html>\n')
            
            fileobject4seven.write('<style type="text/css" media="all">\n')
            fileobject4seven.write(' @import "http://www.yoursevenxi.org/css/halongbay.css";\n')
            fileobject4seven.write('</style> \n')
            fileobject4seven.write('<p>\n')
            fileobject4seven.write('<br /><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b>\n')
            fileobject4seven.write('<br /><a id="000">yourseven<b>&Xi;</b> @Content</a>\n')
            fileobject4seven.write('<br /><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b>\n')
            fileobject4seven.write('<br /> \n')

        except:
            print("(Step 4Z3/33) OF SHOOT2SEVEN4SEARCH *** FAILED TO WRITE TO OUTPUT: ", fileobject4seven)         
            #      
        
        
        KB2name4seven = {}
        key2name4seven = 0
                 
        for file2walk in DirectoryWalker(path2seven):
            # ------------------------------------------------------------------------------------- 
            #
            # -------------------------------------------------------------------------------------     
            if os.path.isdir(file2walk):
                try:    
                    KB2name4seven [key2name4seven] = file2walk
                    print ("KB2NAME4SEVEN[", key2name4seven, "]: ", KB2name4seven [key2name4seven])
                    # 
                    
                    key2name4seven = key2name4seven + 1

                except:
                    print ("(Step 4Z1/33) OF SHOOT2SEVEN4SEARCH - FAILED UPDATING KB2NAME4SEVEN WITH FILE2WALK: " + file2walk + '\n')     
            else:
                build2hyperlink4seven(file2walk)
        
        # --------------------------------------------------------------------------------------------- 
        # END
        # --------------------------------------------------------------------------------------------- 
        try:
            fileobject4seven.write('<br /> \n')
            fileobject4seven.write('<br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br />\n')
            fileobject4seven.write('<br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br />\n')
            fileobject4seven.write('<br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /> \n')
            fileobject4seven.write('<br />~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n')
            fileobject4seven.write('<br />Small & Smart Inc reserves rights to change this document without any notice\n')
            fileobject4seven.write('<br />~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n')
            fileobject4seven.write('</p>\n')
            # 
            fileobject4seven.write('</html>\n')
        except:
            print("(Step 4Z4/33) OF SHOOT2SEVEN4SEARCH *** FAILED TO WRITE TO OUTPUT: ", fileobject4seven)         
            #            
        try:    
            fileobject4seven.close()
            print("(Step 4C/33) OF SHOOT2SEVEN4SEARCH - CLOSED OUTPUT: ", fileobject4seven)         
            # SHOOT2SEVEN4SEARCH - CLOSED OUTPUT:  <_io.TextIOWrapper name='F://temp//yophotos//test2seven//index2xxxxxxxx4yo.html' mode='w' encoding='cp1252'>   
        except:
            print("(Step 4Z5/33) OF SHOOT2SEVEN4SEARCH *** FAILED TO CLOSE OUTPUT: ", fileobject4seven)         
            #                  
                
                
        print("(STEP 5A/33) OF SHOOT2SEVEN4SEARCH - STARTING TO ANALYSE KB2NAME4SEVEN: ", time4xi())
        # STARTING TO ANALYSE KB2NAME4SEVEN:  11:44:16 01/20/15 FLE Standard Time
        
        AlphaKB4seven  = {}
        AlphaKB4seven['a'] = {}
        AlphaKB4seven['b'] = {}
        AlphaKB4seven['c'] = {}
        AlphaKB4seven['d'] = {}
        AlphaKB4seven['e'] = {}
        AlphaKB4seven['f'] = {}
        AlphaKB4seven['g'] = {}
        AlphaKB4seven['h'] = {}
        AlphaKB4seven['i'] = {}
        AlphaKB4seven['j'] = {}
        AlphaKB4seven['k'] = {}
        AlphaKB4seven['l'] = {}
        AlphaKB4seven['m'] = {}
        AlphaKB4seven['n'] = {}
        AlphaKB4seven['o'] = {}
        AlphaKB4seven['p'] = {}
        AlphaKB4seven['q'] = {}
        AlphaKB4seven['r'] = {}
        AlphaKB4seven['s'] = {}
        AlphaKB4seven['t'] = {}
        AlphaKB4seven['u'] = {}
        AlphaKB4seven['v'] = {}
        AlphaKB4seven['w'] = {}
        AlphaKB4seven['x'] = {}
        AlphaKB4seven['y'] = {}
        AlphaKB4seven['z'] = {} 
        keys2AlphaKB4seven = AlphaKB4seven.keys()
        key2AlphaKB4seven  = 0
        
        
        # LEVELS FOR PATH
        KB2level1 = {}
        KB2level2 = {}
        KB2level3 = {}
        KB2level4 = {}
        KB2level5 = {}
        KB2level6 = {}
        KB2level7 = {}
        KB2level8 = {}
        
        key2level1 = 0
        key2level2 = 0
        key2level3 = 0
        key2level4 = 0
        key2level5 = 0
        key2level6 = 0
        key2level7 = 0
        key2level8 = 0
        
        len2cut4seven = len(path2seven)
        # 
        
        keys2name4seven = KB2name4seven.keys()
                
        for key2name4seven in sorted(keys2name4seven):
            # 
            name2optimize4seven = KB2name4seven[key2name4seven]
            # 
            shortcut2level4seven = name2optimize4seven[len2cut4seven:]
            # 
            len2shortcut4seven = len(shortcut2level4seven)
            if len2shortcut4seven == 1:
                try:
                    # LEVEL SEVEN CONSISTS OF ALPHABETIC FOLDERS A ... Z
                    if shortcut2level4seven in keys2AlphaKB4seven:
                        KB2level1[key2level1] = shortcut2level4seven
                        # 
                        key2level1 = key2level1 + 1
                    else:
                        print ("(Step 5Z1/33) OF SHOOT2SEVEN4SEARCH ** WARNING - SHORTCUT2LEVEL4SEVEN: ", shortcut2level4seven, " NOT IN KEYS2ALPHAKB4SEVEN: ", keys2AlphaKB4seven)
                except:
                        print ("(Step 5Z2/33) OF SHOOT2SEVEN4SEARCH *** FAILED - SHORTCUT2LEVEL4SEVEN: ", shortcut2level4seven)      
            else:
                try:
                    
                    string2search4seven = '\\'
                    shortcut2level4seven = shortcut2level4seven[2:]
                    
                    index2level4seven=str.find(shortcut2level4seven,string2search4seven)
                    if index2level4seven == -1:
                         
                        KB2level2[key2level2] = shortcut2level4seven
                        key2level2 = key2level2 + 1
                    else:    
                        shortcut2level4seven = shortcut2level4seven[index2level4seven+1:]
                        index2level4seven=str.find(shortcut2level4seven,string2search4seven)
                        if index2level4seven == -1:
                            KB2level3[key2level3] = shortcut2level4seven
                            key2level3 = key2level3 + 1
                        else:
                            shortcut2level4seven = shortcut2level4seven[index2level4seven+1:]
                            index2level4seven=str.find(shortcut2level4seven,string2search4seven)
                            if index2level4seven == -1:
                                KB2level4[key2level4] = shortcut2level4seven
                                key2level4 = key2level4 + 1
                            else:
                                shortcut2level4seven = shortcut2level4seven[index2level4seven+1:]
                                index2level4seven=str.find(shortcut2level4seven,string2search4seven)
                                if index2level4seven == -1:
                                    KB2level5[key2level5] = shortcut2level4seven
                                    key2level5 = key2level5 + 1
                                else: 
                                    shortcut2level4seven = shortcut2level4seven[index2level4seven+1:]
                                    index2level4seven=str.find(shortcut2level4seven,string2search4seven)
                                    if index2level4seven == -1:
                                        KB2level6[key2level6] = shortcut2level4seven
                                        key2level6 = key2level6 + 1
                                    else:
                                        shortcut2level4seven = shortcut2level4seven[index2level4seven+1:]
                                        index2level4seven=str.find(shortcut2level4seven,string2search4seven)
                                        if index2level4seven == -1:
                                            KB2level7[key2level7] = shortcut2level4seven
                                            key2level7 = key2level7 + 1
                                        else:
                                            shortcut2level4seven = shortcut2level4seven[index2level4seven+1:]
                                            index2level4seven=str.find(shortcut2level4seven,string2search4seven)
                                            if index2level4seven == -1:
                                                KB2level8[key2level8] = shortcut2level4seven
                                                key2level8 = key2level8 + 1                
                                            else:
                                                print ("(Step 5Z2/33) OF SHOOT2SEVEN4SEARCH ** WARNING: MOTE THAN 8 LEVELS, SHORTCUT2LEVEL4SEVEN: ", shortcut2level4seven)
                except:
                    print ("(Step 5Z3/33) OF SHOOT2SEVEN4SEARCH *** FAILED - SHORTCUT2LEVEL4SEVEN: ", shortcut2level4seven)   
        
        print ("(Step 6A/33) OF SHOOT2SEVEN4SEARCH - TRYING TO PRINT KB2level1 ", time4xi())       
        # SHOOT2SEVEN4SEARCH - TRYING TO PRINT KB2level1  11:44:16 01/20/15 FLE Standard Time
        try:
            keys2Level1 = KB2level1.keys()
            for key2Level1 in sorted(keys2Level1):
                print (KB2level1[key2Level1])      
                # a ... z          
        except:
            print ("(Step 6Z1/33) OF SHOOT2SEVEN4SEARCH *** FAILED TO PRINT KB2level1 ", time4xi())    

        print ("(Step 6B/33) OF SHOOT2SEVEN4SEARCH - TRYING TO PRINT KB2level2 ", time4xi())        
        # SHOOT2SEVEN4SEARCH - TRYING TO PRINT KB2level2  11:44:16 01/20/15 FLE Standard Time
        try:
            keys2Level2 = KB2level2.keys()
            for key2Level2 in sorted(keys2Level2):
                print (KB2level2[key2Level2])      
                # sevenfly29july2012    
        except:
            print ("(Step 6Z2/33) OF SHOOT2SEVEN4SEARCH *** FAILED TO PRINT KB2level2 ", time4xi()) 
            
        print ("(Step 6C/33) OF SHOOT2SEVEN4SEARCH - TRYING TO PRINT KB2level3 ", time4xi())       
        try:
            keys2Level3 = KB2level3.keys()
            for key2Level3 in sorted(keys2Level3):
                print (KB2level3[key2Level3])      
                # 
        except:
            print ("(Step 6Z3/33) OF SHOOT2SEVEN4SEARCH *** FAILED TO PRINT KB2level3 ", time4xi())             
        
        print ("(Step 6D/33) OF SHOOT2SEVEN4SEARCH - TRYING TO PRINT KB2level4 ", time4xi())       
        # 
        try:
            keys2Level4 = KB2level4.keys()
            for key2Level4 in sorted(keys2Level4):
                print (KB2level4[key2Level4])      
                #            
        except:
            print ("(Step 6Z4/33) OF SHOOT2SEVEN4SEARCH *** FAILED TO PRINT KB2level4 ", time4xi())                                         
        
        print ("(Step 6E/33) OF SHOOT2SEVEN4SEARCH - TRYING TO PRINT KB2level5 ", time4xi())       
        # 
        try:
            keys2Level5 = KB2level5.keys()
            for key2Level5 in sorted(keys2Level5):
                print (KB2level5[key2Level5])      
                #              
        except:
            print ("(Step 6Z5/33) OF SHOOT2SEVEN4SEARCH *** FAILED TO PRINT KB2level5 ", time4xi())             
        
        print ("(Step 6F/33) OF SHOOT2SEVEN4SEARCH - TRYING TO PRINT KB2level6 ", time4xi())       
        # 
        try:
            keys2Level6 = KB2level6.keys()
            for key2Level6 in sorted(keys2Level6):
                print (KB2level6[key2Level6])      
                #              
        except:
            print ("(Step 6Z6/33) OF SHOOT2SEVEN4SEARCH *** FAILED TO PRINT KB2level6 ", time4xi())             
    
        print ("(Step 6G/33) OF SHOOT2SEVEN4SEARCH - TRYING TO PRINT KB2level7 ", time4xi())       
        # 
        try:
            keys2Level7 = KB2level7.keys()
            for key2Level7 in sorted(keys2Level7):
                print (KB2level7[key2Level7])      
                #              
        except:
            print ("(Step 6Z7/33) OF SHOOT2SEVEN4SEARCH *** FAILED TO PRINT KB2level7 ", time4xi()) 
            
        print ("(Step 6H/33) OF SHOOT2SEVEN4SEARCH - TRYING TO PRINT KB2level8 ", time4xi())       
        # 
        try:
            keys2Level8 = KB2level8.keys()
            for key2Level8 in sorted(keys2Level8):
                print (KB2level8[key2Level8])      
                #              
        except:
            print ("(Step 6Z8/33) OF SHOOT2SEVEN4SEARCH *** FAILED TO PRINT KB2level8 ", time4xi())         
        
        print ("(Step 7A/33) OF SHOOT2SEVEN4SEARCH - TRYING TO PRINT STATISTICS ", time4xi())   
        #     
        try:    
            print ("(Step 7B/33) OF SHOOT2SEVEN4SEARCH - COUNT2ACK4SEVEN; ", count2ack4seven)
            # COUNT2ACK4SEVEN;  3 <-- *.jpg
            print ("(Step 7C/33) OF SHOOT2SEVEN4SEARCH - COUNT2NACK4SEVEN; ", count2nack4seven)
            # COUNT2NACK4SEVEN;  2 <-- index.html
            print ("(Step 7D/33) OF SHOOT2SEVEN4SEARCH - COUNT2FOUND4SEVEN: ", count2found4seven)
            # COUNT2FOUND4SEVEN:  5 <-- all files
        except:
             print ("(Step 7Z1/33) OF SHOOT2SEVEN4SEARCH *** FAILED TO PRINT STATISTICS ", time4xi())
        
        try:  
            print ("(Step 7E/33) OF SHOOT2SEVEN4SEARCH - FOUND MAX SIZE: ", maxsize2ack4seven)
            #  3866624
            print ("(Step 7F/33) OF SHOOT2SEVEN4SEARCH - ALLOWED MAX SIZE: ", maxsize2file4seven)
            # 33000000
        except:
             print ("(Step 7Z2/33) OF SHOOT2SEVEN4SEARCH *** FAILED TO PRINT STATISTICS ", time4xi())
        
        try:         
            if count2found4seven == 0:
                meansize2ack4seven = 0
                print ("(Step 7G1/33) OF SHOOT2SEVEN4SEARCH - MEAN SIZE SET: ", meansize2ack4seven)
                #  
            else:       
                meansize2ack4seven = int(sumsize2ack4seven / count2ack4seven)
                print ("(Step 7G2/33) OF SHOOT2SEVEN4SEARCH - MEAN SIZE CALCULATED: ", meansize2ack4seven, ", WHERE SUMSIZE2ACK4SEVEN: ", sumsize2ack4seven, " COUNT2ACK4SEVEN: ", count2ack4seven)
                # MEAN SIZE CALCULATED:  3648170 , WHERE SUMSIZE2ACK4SEVEN:  10944512  COUNT2ACK4SEVEN:  3 
        except:
             print ("(Step 7Z3/33) OF SHOOT2SEVEN4SEARCH *** FAILED TO CALCULATE STATISTICS ", time4xi())
        
        try:                 
            if minsize2ack4seven < maxsize2file4seven:
                print ("(Step 7H/33) OF SHOOT2SEVEN4SEARCH - MIN SIZE MET: ", minsize2ack4seven)
                # 3538944
            else:
                print ("(Step 7I/33) OF SHOOT2SEVEN4SEARCH ** MIN DEFINED: ", minsize2ack4seven, " EQUALS TO MAXSIZE2FILE4SEVEN: ", maxsize2file4seven)        
        except:
             print ("(Step 7Z4/33) OF SHOOT2SEVEN4SEARCH *** FAILED TO PRINT STATISTICS ", time4xi())
             
                         
        print("(STEP 4Y/33) OF SHOOT2SEVEN4SEARCH - RETURNING: ", time4xi(), " HAVING STARTED: ", time2start) 
        # 12:26:08 01/20/15 FLE Standard Time  HAVING STARTED:  12:26:08 01/20/15 FLE Standard Time
 
        
               
        return
    else:
        # -----------------------------------------------------------------------------------------
        # UNEXPECTED PARAMETER COMBINATION - ERROR
        # -----------------------------------------------------------------------------------------
        print("(STEP 7Z1/33) OF SHOOT2SEVEN4SEARCH *** ERROR IN LOGIC ***")
        print("(STEP 7Z2/33) OF SHOOT2SEVEN4SEARCH - QUEUE2SEVEN: ", queue2seven)
        print("(STEP 7Z3/33) OF SHOOT2SEVEN4SEARCH - CONSUMER_CHANNEL2SEVEN: ", consumer_channel2seven) 
        print("(STEP 7Z4/33) OF SHOOT2SEVEN4SEARCH - PUBLISHER_CHANNEL2SEVEN: ", publisher_channel2seven)
        print("(STEP 7Z5/33) OF SHOOT2SEVEN4SEARCH - PATH2SEVEN: ", path2seven)     
              
        return  
            
               
#</function4xi>


#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
# ROOT4XI\Studio4Xi\Python\3.3\txt\analyse2photo4search.txt
# \xml\ace-analyse2photo.xml
# \xml\reason-analyse2photo.xml
# \xml\sense-analyse2photo.xml
# 
#"
#>
  

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.sevenxi.com; www.yoursevenxi.com; www.yoursevenxi.org; www.seven2xi.com/; www.seven4xi.com/; www.seven8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of shoot2seven4search.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
